<div class="col-lg-12 animated fadeInRight list-devices">
    <div class="input-group">
    </div>
    <div class="wrapper wrapper-content animated fadeInRight">
        <div class="row">
            <div class="col-lg-12">
                <div class="ibox float-e-margins">
                    <div class="ibox-title">
                        <div class="row">
                            <div class="col-sm-12">
                                <h3>
                                    <strong>Manage Devices</strong>
                                </h3>
                            </div>
                        </div>
                        <div class="fm-row">
                            <div class="row ">
                                <div class="col-sm-3">
                                    <input [(ngModel)]="deviceForm" [formControl]="device" type="text"
                                        placeholder="Select device" [matAutocomplete]="devices"
                                        class="form-control custom-class-border" (ngModelChange)="searchDevice($event)">
                                    <img *ngIf="loadingIndicator == 'searchDevice'" class="loading_indicator"
                                        src="assets/img/loading.gif" alt="loader"/>
                                    <mat-autocomplete #devices="matAutocomplete" [displayWith]="displayFnDevice">
                                        <mat-option *ngFor="let device of deviceData2" [value]="device">
                                            <div class="option-otr">
                                                <div class="option_span">{{device.unique_device_id}}</div>
                                                <div class="option_span"> {{device.device_model}}</div>
                                            </div>
                                        </mat-option>
                                        <mat-option *ngIf="deviceData2 == '' && deviceData2.length == 0">No Matches
                                            Found</mat-option>
                                    </mat-autocomplete>
                                </div>
                                <div class="col-xs-3 list-driver">
                                    <input matInput placeholder="Select Driver" class="form-control custom-class-border"
                                        name="driver_id" (ngModelChange)="searchDriver($event)" [(ngModel)]="driverForm"
                                        [formControl]="queryField" aria-label="Driver" [matAutocomplete]="Drivers">
                                    <img *ngIf="loadingIndicator == 'searchDriver'" class="loading_indicator"
                                        src="assets/img/loading.gif" alt="loader"/>
                                    <mat-autocomplete #Drivers="matAutocomplete" [displayWith]="displayFnDriver">
                                        <mat-option *ngFor="let driver of driverData" [value]="driver">
                                            <span class="img-otr">
                                                <img style="vertical-align:middle;" aria-hidden
                                                    src="{{driver.profile_picture ? apiUrl + driver.profile_picture+imageext : '../../assets/img/noimage.jpg'}}" alt="my Dtc img"
                                                    height="25" />
                                            </span>
                                            <div class="option-otr">
                                                <div class="option_span">
                                                    <strong>Username:</strong>{{ driver.username }}</div>
                                                <div class="option_span">
                                                    <strong>Name and Surname:</strong>{{ driver.name }} &nbsp;{{ driver.surname }}
                                                </div>
                                                <div class="option_span">
                                                    <strong>Display Name:</strong>{{ driver.display_name }}</div>
                                            </div>
                                        </mat-option>
                                        <mat-option *ngIf="driverData == '' && driverData.length == 0">No Matches Found
                                        </mat-option>
                                    </mat-autocomplete>
                                </div>
                                <div class="col-sm-3">
                                    <select [(ngModel)]="isBlocked_status" name="isBlocked_status"
                                        placeholder="Device status" class="form-control">
                                        <option value="" hidden>Device status</option>
                                        <option [value]="1">Blocked</option>
                                        <option [value]="2">Unblocked</option>
                                        <option [value]="3">Permanently Blocked</option>
                                    </select>
                                </div>
                                <div class="col-sm-3">
                                    <input matInput placeholder="Select Driver id"
                                        class="form-control custom-class-border" name="driveruniqueid"
                                        (ngModelChange)="searchDriverId($event)" [(ngModel)]="driverIdForm"
                                        [formControl]="driver_Id" aria-label="driverId" [matAutocomplete]="uniqueDid">
                                    <img *ngIf="loadingIndicator == 'searchDriverId'" class="loading_indicator"
                                        src="assets/img/loading.gif" alt="loader"/>
                                    <mat-autocomplete #uniqueDid="matAutocomplete" [displayWith]="displayFnDriverId">
                                        <mat-option *ngFor="let driverID of driverIdData" [value]="driverID">
                                            <div class="option-otr">
                                                <span>{{ driverID.emp_id}}</span>
                                            </div>
                                        </mat-option>
                                        <mat-option *ngIf="driverIdData == '' && driverIdData.length == 0">No Matches
                                            Found</mat-option>
                                    </mat-autocomplete>
                                </div>
                            </div>
                        </div>
                        <div class="fm-row">
                            <div class="row ">
                                <div class="col-sm-3" *ngIf="dtc">
                                    <mat-select [(ngModel)]="companyIdFilter" placeholder="Company"
                                        (change)="changeCompany()" class="form-control custom-class-border" multiple>
                                        <mat-option value="all" (click)="selectAllCompany()">All</mat-option>
                                        <mat-option (click)="companyManualSelect()" *ngFor="let company of companyData" [value]="company._id">
                                            {{company.company_name}}
                                        </mat-option>
                                    </mat-select>
                                </div>
                                <div class="col-sm-3">
                                    <input matInput placeholder="Select Vehicle No"
                                        class="form-control custom-class-border" name="vehicle_side_no"
                                        (ngModelChange)="searchVehichleSidenumber($event)" [(ngModel)]="sideForm"
                                        [formControl]="vehicle_side_no" aria-label="vehicleSide"
                                        [matAutocomplete]="vehichleSide">

                                    <img *ngIf="loadingIndicator == 'searchVehichleSidenumber'"
                                        class="loading_indicator" src="assets/img/loading.gif" alt="loader"/>

                                    <mat-autocomplete #vehichleSide="matAutocomplete"
                                        [displayWith]="displayFnVehichleSide">
                                        <mat-option *ngFor="let vehichle1 of vehichleSideData" [value]="vehichle1">
                                            <span>{{ vehichle1.vehicle_identity_number}}</span>
                                        </mat-option>
                                        <mat-option *ngIf="vehichleSideData == '' && vehichleSideData.length == 0">No
                                            Matches Found</mat-option>
                                    </mat-autocomplete>
                                </div>
                                <div class="col-sm-3">
                                    <input matInput placeholder="Select Plate Number"
                                        class="form-control custom-class-border" name="vehichle_plate_no"
                                        (ngModelChange)="searchVehichlePlateNumber($event)" [(ngModel)]="plateForm"
                                        [formControl]="vehicle_plate_no" aria-label="VehichlePlate"
                                        [matAutocomplete]="vehichlePlate">

                                    <img *ngIf="loadingIndicator == 'searchVehichlePlateNumber'"
                                        class="loading_indicator" src="assets/img/loading.gif" alt="loader"/>

                                    <mat-autocomplete #vehichlePlate="matAutocomplete"
                                        [displayWith]="displayFnVehichlePlate">
                                        <mat-option *ngFor="let vehichle2 of vehichlePlateData" [value]="vehichle2">
                                            <div class="option-otr">
                                                <span>{{ vehichle2.plate_number}}</span>
                                            </div>
                                        </mat-option>
                                        <mat-option *ngIf="vehichlePlateData == '' && vehichlePlateData.length == 0">No
                                            Matches Found</mat-option>
                                    </mat-autocomplete>
                                </div>

                                <div class="col-sm-3">
                                    <select [(ngModel)]='pageSize' name='pageSize' class="form-control">
                                        <option value="10">10 records</option>
                                        <option value="20">20 records</option>
                                        <option value="30">30 records</option>
                                        <option value="50">50 records</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="fm-row">
                            <div class="row ">
                                <div class="col-sm-4">
                                    <input matInput placeholder="Select IMEI Number"
                                        class="form-control custom-class-border" name="imei_number"
                                        (ngModelChange)="searchDevice($event)" [(ngModel)]="imeiForm"
                                        [formControl]="imei_no" aria-label="imei" [matAutocomplete]="imei">

                                    <img *ngIf="loadingIndicator == 'searchIMEINumber'" class="loading_indicator"
                                        src="assets/img/loading.gif" alt="create loader"/>

                                    <mat-autocomplete #imei="matAutocomplete" [displayWith]="displayFnIMEI">
                                        <mat-option *ngFor="let devices of deviceData3" [value]="devices">
                                            <div class="option-otr">
                                                <div class="option_span" *ngIf='devices.imei!=""'>IMEI :
                                                    {{ devices.imei}}
                                                </div>
                                                <div class="option_span" *ngIf='devices.imei==""'>IMEI : NA</div>
                                                <div class="option_span">DEVICE ID : {{ devices.unique_device_id}}</div>
                                            </div>
                                        </mat-option>
                                        <mat-option *ngIf="deviceData3 == '' && deviceData3.length == 0">No
                                            Matches Found</mat-option>
                                    </mat-autocomplete>
                                </div>
                                <div class="col-sm-4">
                                    <mat-select [(ngModel)]="appVersion" placeholder="Device version"
                                        class="form-control custom-class-border" multiple>
                                        <mat-option *ngFor="let versions of appVersionArr" [value]="versions._id">
                                            {{versions.version}}
                                        </mat-option>
                                    </mat-select>
                                </div>
                            </div>
                        </div>
                        <div class="fm-row">
                            <div class="row ">
                                <div class="col-sm-12 text-right">
                                    <div class="col-sm-4 text-left">
                                        <ng-container *ngIf="aclDelete">
                                            <button (click)="openDeleteArrayDialog()"
                                                class="btn btn-sm btn-primary red">
                                                <i aria-hidden="true" class="fa fa-trash"></i> Delete Selected</button>
                                        </ng-container>
                                    </div>
                                    <div class="col-sm-8 text-right">
                                        <ng-container *ngIf="downloads">
                                            <span matTooltip="CSV" style="cursor:pointer">
                                                <img src="assets/img/csv.png" (click)="createCsv()" alt="create loader"/>
                                            </span>
                                        </ng-container>
                                        <button type="get" (click)="getDevices();" class="btn btn-sm btn-primary blue">
                                            <i aria-hidden="true" class="fa fa-search"></i> Search</button>
                                        <button class="btn btn-sm btn-primary green" (click)="refresh()">
                                            <i aria-hidden="true" class="fa fa-refresh"></i>
                                            Refresh
                                        </button>
                                        <button class="btn btn-sm btn-primary red" (click)="reset()">
                                            <i aria-hidden="true" class="fa fa-eraser"></i>
                                            Reset filters
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="ibox-content" *ngIf="pageNo==0">

                            showing records {{pageNo+1}}-{{(pageNo+1)*pageSize}}/{{deviceLength}}
                        </div>
                        <div class="ibox-content" *ngIf="pageNo!==0">

                            showing records {{pageNo}}-{{((pageNo/pageSize+1)*pageSize)}}/{{deviceLength}}
                        </div>
                        <div class="ibox-content">
                            <div class="table-responsive">
                                <table aria-describedby="Manage Company" class="table table-striped table-bordered table-responsive zoom">
                                    <thead>
                                        <tr>
                                            <th scope="col" class="text-center">
                                                <input type="checkbox" [(ngModel)]="selectedAll"
                                                    (change)="selectAll()" />
                                            </th>
                                            <th scope="col" (click)="sort('unique_device_id')">ID
                                                <span>
                                                    <i aria-hidden="true" class="fa fa-sort-asc fa_custom up"
                                                        [ngClass]="{'sorted-color': sortOrder=='desc' && key =='unique_device_id' }"></i>
                                                    <i aria-hidden="true" class="fa fa-sort-desc fa_custom down"
                                                        [ngClass]="{'sorted-color': sortOrder=='asc' && key =='unique_device_id' }"></i>
                                                </span>
                                            </th>

                                            <th scope="col" style="width: 111px;" (click)="sort('device_model')">Device Model
                                                <span>
                                                    <i aria-hidden="true" class="fa fa-sort-asc fa_custom up"
                                                        [ngClass]="{'sorted-color': sortOrder=='desc' && key =='device_model' }"></i>
                                                    <i aria-hidden="true" class="fa fa-sort-desc fa_custom down"
                                                        [ngClass]="{'sorted-color': sortOrder=='asc' && key =='device_model' }"></i>
                                                </span>
                                            </th>

                                            <th scope="col" (click)="sort('ud_id')">IMEI
                                                <span>
                                                    <i aria-hidden="true" class="fa fa-sort-asc fa_custom up"
                                                        [ngClass]="{'sorted-color': sortOrder=='desc' && key =='imei' }"></i>
                                                    <i aria-hidden="true" class="fa fa-sort-desc fa_custom down"
                                                        [ngClass]="{'sorted-color': sortOrder=='asc' && key =='imei' }"></i>
                                                </span>
                                            </th>
                                            <th scope="col" style="width: 91px;" (click)="sort('company')">Credit Machine
                                            </th>
                                            <th scope="col">App Version</th>
                                            <th scope="col">Device Status</th>
                                            <th scope="col" *ngIf="aclEditDriver">Driver</th>
                                            <th scope="col" *ngIf="aclEditVehicle">Vehicle</th>
                                            <th scope="col" *ngIf="aclTempBlock" (click)="sort('isBlocked_status')">Temporary Block
                                                Status
                                                <span>
                                                    <i aria-hidden="true" class="fa fa-sort-asc fa_custom up"
                                                        [ngClass]="{'sorted-color': sortOrder=='desc' && key =='isBlocked_status' }"></i>
                                                    <i aria-hidden="true" class="fa fa-sort-desc fa_custom down"
                                                        [ngClass]="{'sorted-color': sortOrder=='asc' && key =='isBlocked_status' }"></i>
                                                </span>
                                            </th>
                                            <th scope="col" *ngIf="aclTPermBlock">Permanent Block Status
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <span *ngIf="searchSubmit">
                                            <img alt="loader" src="assets/img/loader.gif" class="loader-img" alt="loader"/>
                                        </span>
                                        <tr *ngFor="let devices of deviceData; let i = index" [attr.data-index]="i">
                                            <td class="text-center">
                                                <input type="checkbox" [(ngModel)]="devices.selected"
                                                    [checked]="devices.checked"
                                                    (change)="checkIfAllSelected(devices, i)">
                                            </td>
                                            <td>{{devices.unique_device_id }}</td>
                                            <td>{{devices.device_model }}</td>
                                            <td>{{devices.imei?devices.imei:'NA' }}</td>
                                            <td>{{devices.vehicle_id[0]?devices.vehicle_id[0].credit_card?devices.vehicle_id[0].credit_card:'NA':'NA' }}
                                            </td>
                                            <td>{{devices.app_version ? devices.app_version : 'N/A'}}</td>
                                            <td>
                                                <ng-container *ngIf="devices.isBlocked_status == '0' || devices.isBlocked_status=='2'">Unblocked</ng-container>
                                                <ng-container *ngIf="(devices.isBlocked_status == '1' || devices.isBlocked_status == '4') && devices.isBlocked_status != '3'">
                                                    <p *ngIf="devices.bl_by">Blocked By : {{devices.bl_by}}</p>
                                                    <p *ngIf="devices.reason !=''">Block Reason : {{devices.reason}}</p>
                                                    <p *ngIf="devices.note!=''"> Note : {{devices.note}}</p>
                                                </ng-container>
                                            </td>
                                            <td *ngIf="aclEditDriver">
                                                {{devices.driver_id ? devices.driver_id.username : 'N/A'}}
                                                <button class="btn btn-sm btn-primary" (click)="Driver(devices)">Edit
                                                    Driver</button>
                                            </td>
                                            <td *ngIf="aclEditVehicle" class="text-center">
                                                <button class="btn btn-sm btn-primary" (click)="Vehicle(devices)">Edit
                                                    Vehicle</button><br />
                                                {{devices.vehicle_id[0]?devices.vehicle_id[0].display_name:''}}
                                            </td>
                                            <ng-container *ngIf="aclTempBlock">

                                                <td
                                                    *ngIf="(devices.isBlocked_status == '1' || devices.isBlocked_status == '4') && devices.isBlocked_status != '3'">
                                                    <button [disabled]="checkIfPressed(devices.unique_device_id)"
                                                        class=" btn btn-sm btn-danger "
                                                        (click)="openDialogToUnblock(devices,i,'u')">Blocked</button>
                                                    <p>{{devices.reason}}</p>
                                                    <p *ngIf="devices.note!=''">Note : {{devices.note}}</p>
                                                    <p *ngIf="checkIfPressed(devices.unique_device_id)">Unblock in
                                                        progress</p>
                                                </td>

                                                <td *ngIf="(devices.isBlocked_status=='0' || devices.isBlocked_status=='2') && devices.isBlocked_status != '3'">
                                                    <button [disabled]="checkIfPressed(devices.unique_device_id)"
                                                        class="btn btn-sm btn-primary "
                                                        (click)="DevicestatusChangePopup(devices, i,'t') ">Unblocked</button>
                                                    <p *ngIf="checkIfPressed(devices.unique_device_id)">Block in
                                                        progress</p>
                                                </td>

                                            </ng-container>

                                            <ng-container *ngIf="aclTPermBlock">
                                                <td *ngIf="devices.isBlocked_status=='3'">
                                                    <button class="btn btn-sm btn-danger ">Blocked permanent</button>
                                                    <p>Block Type: {{devices.reason}}</p>
                                                    <p *ngIf="devices.note!=''">Note : {{devices.note}}</p>
                                                </td>
                                                <td *ngIf="devices.isBlocked_status=='3'">
                                                    <button class=" btn btn-sm btn-danger ">Blocked permanent</button>
                                                    <p>Block Type: {{devices.reason}}</p>
                                                    <p *ngIf="devices.note!=''">Note : {{devices.note}}</p>
                                                </td>
                                                <td *ngIf="devices.isBlocked_status!='3'">
                                                    <button class=" btn btn-sm btn-primary "
                                                        (click)="DevicestatusChangePopup(devices, i,'p')">Block
                                                        permanent</button>
                                                </td>
                                            </ng-container>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div style="text-align:center; margin-left:125px;"
                                *ngIf="deviceLength===0 || deviceLength === undefined">
                                No records found
                            </div>
                            <br>
                            <div class="container-fluid" *ngIf="deviceLength > 0" ng-show="view_data.length!=0">
                                <div class="row col-md-12 text-center">
                                    <div class="dataTables_info1">
                                        <div *ngIf="del">
                                            <ngb-pagination [collectionSize]="deviceLength" [(page)]="pNo"
                                                [pageSize]="pageSize" (pageChange)="pagingAgent($event)"
                                                aria-label="Default pagination" [maxSize]="5" [boundaryLinks]="true">
                                            </ngb-pagination>
                                        </div>
                                        <div *ngIf="!del">
                                            <ngb-pagination [collectionSize]="deviceLength"
                                                (pageChange)="pagingAgent($event)" [page]="1" [pageSize]="pageSize"
                                                aria-label="Default pagination" [maxSize]="5" [boundaryLinks]="true">
                                            </ngb-pagination>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>